<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2003 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

if (!eregi("admin.php", $PHP_SELF)) { die ("Access Denied"); }

if (!pnSecAuthAction(0, 'AutoTheme::', '::', ACCESS_ADMIN)) {
    die("Access Denied");
}
define('STARTPHP', str_replace('&lt;', '<', '&lt;?php'));
define('ENDPHP', str_replace('&gt;', '>', '?&gt;'));

modules_get_language();

function AutoConvert_admin_main($vars)
{
    extract($vars);
    
    include("header.php");

    OpenTable();

    echo '<form method="POST" action="admin.php">'
         .'     <input type="hidden" name="module" value="AutoConvert">'
         .'     <input type="hidden" name="op" value="convert">'
         .'     '._AC_OLDTHEME.':<br />'
         .'     <input type="text" name="theme" size="20"><br />'
         .'     '._AC_NEWTHEME.':<br />'
         .'     <input type="text" name="newtheme" size="20"><br />'
         .'     <input type="submit" value="'._AC_CONVERT.'" name="B1">'
         .'</form>';

    CloseTable();
    include("footer.php");
}

function AutoConvert_admin_convert($vars)
{
    extract($vars);
    
    $old_mask = umask(0);
    
    $oldthemepath = "themes/$theme";
    $newthemepath = "themes/$newtheme";
    
    if (!is_writeable("themes/")) {
        die("themes/ directory is not writeable!");
    }
    mkdir($newthemepath);
    mkdir("$newthemepath/images");
    mkdir("$newthemepath/style");
    
    chmod($newthemepath, 0777);
    chmod("$newthemepath/images", 0777);
    chmod("$newthemepath/style", 0777);
    
    //copy files
    copy("modules/AutoConvert/tools/AT-Blank/theme.cfg", "$newthemepath/theme.cfg");
    copy("modules/AutoConvert/tools/AT-Blank/theme.php", "$newthemepath/theme.php");
    copy("modules/AutoConvert/tools/AT-Blank/pninit.php", "$newthemepath/pninit.php");
    copy("modules/AutoConvert/tools/AT-Blank/images/at-powered.gif", "$newthemepath/images/at-powered.gif");

    if ($handle = @opendir("$oldthemepath/images/")) {
            while (false !== ($file = @readdir($handle))) {
                if ($file == "." || $file == "..") {
                    continue;
                }
                copy("$oldthemepath/images/$file", "$newthemepath/images/$file");
            }
            closedir($handle);
    }
    if ($handle = @opendir("$oldthemepath/style/")) {
            while (false !== ($file = @readdir($handle))) {
                if ($file == "." || $file == "..") {
                    continue;
                }
                copy("$oldthemepath/style/$file", "$newthemepath/style/$file");
            }
            closedir($handle);
    }
    
    //fix theme.php
    copy("$oldthemepath/theme.php", "$oldthemepath/theme.php.bak");
    
    $content = file_get_contents("$oldthemepath/theme.php");

    $search = array (
        '/blocks\([\"\'](l|left)[\"\']\);/',
        '/blocks\([\"\'](r|right)[\"\']\);/',
        '/blocks\([\"\'](c|center|centre)[\"\']\);/'
    );

    $replace = array (
        'echo "<!-- [left-blocks] -->";',
        'echo "<!-- [right-blocks] -->";',
        'echo "<!-- [center-blocks] -->";'
    );

    $content = preg_replace($search, $replace, $content);

    $handle = fopen("$oldthemepath/theme.php", "w");
	fwrite($handle, $content);
	fclose($handle);
    
    //include cms and theme
    ob_start();
    include("header.php");
    include("footer.php");
    ob_end_clean();
    
    error_reporting(E_ALL^E_WARNING^E_NOTICE);
    
   	copy("$oldthemepath/theme.php.bak", "$oldthemepath/theme.php");
   	unlink("$oldthemepath/theme.php.bak");
    
    //include config
    include("$newthemepath/theme.cfg");
    
    //add colors
    $style['default']['color1'] = $GLOBALS['bgcolor1'];
    $style['default']['color2'] = $GLOBALS['bgcolor2'];
    $style['default']['color3'] = $GLOBALS['bgcolor3'];
    $style['default']['color4'] = $GLOBALS['bgcolor4'];
    $style['default']['color5'] = $GLOBALS['textcolor1'];
    $style['default']['color6'] = $GLOBALS['textcolor2'];
    
    //create color commands
    $GLOBALS['bgcolor1'] = "{color1}";
    $GLOBALS['bgcolor2'] = "{color2}";
    $GLOBALS['bgcolor3'] = "{color3}";
    $GLOBALS['bgcolor4'] = "{color4}";
    $GLOBALS['textcolor1'] = "{color5}";
    $GLOBALS['textcolor2'] = "{color6}";
    
    //create table1	
    ob_start();
    OpenTable();
    $content = ob_get_contents();
    ob_end_flush();

    $content .="<!-- [table-content] -->";

    ob_start();
    CloseTable();
    $content .= ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);
    
    $handle = fopen("$newthemepath/table1.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	//create table2	
    ob_start();
    OpenTable2();
    $content = ob_get_contents();
    ob_end_flush();

    $content .="<!-- [table-content] -->";

    ob_start();
    CloseTable2();
    $content .= ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);
    
    $handle = fopen("$newthemepath/table2.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	$block = array(
           'title' => '<!-- [block-title] -->',
           'content' => '<!-- [block-content] -->',
    );
    //create left block
    $block['position'] = 'l';
    ob_start();
    themesidebox($block);
    $content = ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/leftblock.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
    //create right block	
    $block['position'] = 'r';
    ob_start();
    themesidebox($block);
    $content = ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/rightblock.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	//create center block	
    $block['position'] = 'c';
    ob_start();
    themesidebox($block);
    $content = ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/centerblock.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	//create summary article
	list($preformat, $info, $links) = build_news_commands();
    
    ob_start();
    themeindex($_deprecated, $_deprecated, $_deprecated, $_deprecated,
    $_deprecated, $_deprecated, $_deprecated, $_deprecated, $_deprecated,
    $_deprecated, $_deprecated, $_deprecated, $info, $links, $preformat);
    
    $content = ob_get_contents();
    ob_end_flush();

    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/summary.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	//create full article
    list($preformat, $info, $links) = build_news_commands();

    ob_start();
    themearticle ($_deprecated, $_deprecated, $_deprecated, $_deprecated,
    $_deprecated, $_deprecated, $_deprecated, $_deprecated, $_deprecated,
    $info, $links, $preformat);
    
    $content = ob_get_contents();
    ob_end_flush();
    
    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/article.html", "w");
	fwrite($handle, $content);
	fclose($handle);
	
	//create main theme
    $GLOBALS['index'] = 1;
    ob_start();
    themeheader();
    $content = ob_get_contents();
    ob_end_flush();
    
    if (!stristr($content, "</head>")) {
        $content = "</head>" . $content;
    }
    $content = "<html>\n<head>\n" . $content;
    $content .= "<!-- [modules] -->";
    
    $GLOBALS['index'] = 1;
    ob_start();
    themefooter();
    $content .= ob_get_contents();
    ob_end_flush();
    
    $content .= "\n<br />\n<div align=\"center\"><a href=\"http://spidean.mckenzies.net\"><img border=\"0\" src=\"{image-path}at-powered.gif\" alt=\"Powered by AutoTheme\"></a>\n";
    $content .= "\n</body>\n</html>";
    $content = trim($content);
    
    //convert paths
    $content = str_replace("$oldthemepath/images/", "{image-path}", $content);
    $content = str_replace("$oldthemepath/", "{theme-path}", $content);

    $handle = fopen("$newthemepath/theme.html", "w");
	fwrite($handle, $content);
	fclose($handle);
    
    //save config
    $content = STARTPHP."\n"
    .'$template = '
    .var_export($template, TRUE)
    .";\n"
    .'$blockdisplay = '
    .var_export($blockdisplay, TRUE)
    .";\n"
    .'$style = '
    .var_export($style, TRUE)
    .";\n"
    .'$blocktemplate = '
    .var_export($blocktemplate, TRUE)
    .";\n"
    .'$themeversion = '
    .var_export($themeversion, TRUE)
    .";\n".ENDPHP;

    $handle = fopen("$newthemepath/theme.cfg", "w");
	fwrite($handle, $content);
	fclose($handle);
	
    header("location: admin.php?module=AutoConvert&op=complete&themedir=$newtheme");
}

function AutoConvert_admin_complete($vars)
{
    extract($vars);

    include("header.php");

    Opentable();
    echo _AC_THEMECONVERTED." themes/$themedir/<br />";
    echo "[ <a target=\"_blank\" href=\"index.php?theme=$themedir\">"._AC_PREVIEW."</a> ]";
    CloseTable();
    
    include("footer.php");
}

function build_news_commands()
{
$html = array (
	'bodytext' => '<!-- [news:html:bodytext] -->',
	'bytesmore' => '<!-- [news:html:bytesmore] -->',
	'category' => '<!-- [news:html:category] -->',
	'comment' => '<!-- [news:html:comment] -->',
	'hometext' => '<!-- [news:html:hometext] -->',
	'notes' => '<!-- [news:html:notes] -->',
	'searchtopic' => '<!-- [news:html:searchtopic] -->',
	'print' => '<!-- [news:html:print] -->',
	'readmore' => '<!-- [news:html:readmore] -->',
	'send' => '<!-- [news:html:send] -->',
	'title' => '<!-- [news:html:title] -->',
	'version' => '<!-- [news:html:version] -->',
	'more' => '<!-- [news:html:more] -->',
	'catandtitle' => '<!-- [news:html:catandtitle] -->',
	'maintext' => '<!-- [news:html:maintext] -->',
	'fulltext' => '<!-- [news:html:fulltext] -->',
);
$text = array (
	'aid' => '<!-- [news:text:aid] -->',
	'bodytext' => '<!-- [news:text:bodytext] -->',
	'catthemeoverride' => '<!-- [news:text:catthemeoverride] -->',
	'cid' => '<!-- [news:text:cid] -->',
	'cattitle' => '<!-- [news:text:cattitle] -->',
	'comments' => '<!-- [news:text:comments] -->',
	'counter' => '<!-- [news:text:counter] -->',
	'hometext' => '<!-- [news:text:hometext] -->',
	'informant' => '<!-- [news:text:informant] -->',
	'notes' => '<!-- [news:text:notes] -->',
	'sid' => '<!-- [news:text:sid] -->',
	'themeoverride' => '<!-- [news:text:themeoverride] -->',
	'tid' => '<!-- [news:text:tid] -->',
	'time' => '<!-- [news:text:time] -->',
	'title' => '<!-- [news:text:title] -->',
	'topicname' => '<!-- [news:text:topicname] -->',
	'topicimage' => '<!-- [news:text:topicimage] -->',
	'topictext' => '<!-- [news:text:topictext] -->',
	'tcounter' => '<!-- [news:text:tcounter] -->',
	'unixtime' => '<!-- [news:text:unixtime] -->',
	'withcomm' => '<!-- [news:text:withcomm] -->',
	'skins' => '<!-- [news:text:skins] -->',
	'topicid' => '<!-- [news:text:topicid] -->',
	'topic' => '<!-- [news:text:topic] -->',
	'catid' => '<!-- [news:text:catid] -->',
	'version' => '<!-- [news:text:version] -->',
	'longdatetime' => '<!-- [news:text:longdatetime] -->',
	'briefdatetime' => '<!-- [news:text:briefdatetime] -->',
	'longdate' => '<!-- [news:text:longdate] -->',
	'briefdate' => '<!-- [news:text:briefdate] -->',
	'catandtitle' => '<!-- [news:text:catandtitle] -->',
	'maintext' => '<!-- [news:text:maintext] -->',
	'fulltext' => '<!-- [news:text:fulltext] -->',
);
$url = array (
	'category' => '<!-- [news:url:category] -->',
	'comment' => '<!-- [news:url:comment] -->',
	'fullarticle' => '<!-- [news:url:fullarticle] -->',
	'searchtopic' => '<!-- [news:url:searchtopic] -->',
	'print' => '<!-- [news:url:print] -->',
	'send' => '<!-- [news:url:send] -->',
	'version' => '<!-- [news:url:version] -->',
);

return array($html, $text, $url);
}

if (!function_exists("file_get_contents")) {
    function file_get_contents($filename)
    {
        if (@is_file($filename)) {
            $result = "";
            $handle = @fopen($filename, "r");
	        if (!$handle) {
                return false;
            }
            while (!feof($handle)) {
                $result .= fread($handle, 4096);
            }
            return $result;
        }
        else {
            return false;
        }
    }
}

?>
